/**
* @brief
websocketͻ

* @version
  V 1.0.0

* @author
  濡

* @date
  ʱ:  2018-08-14\n

* @note
  2018-08-14  ࡣ\n

* @warning

* @bug
  
*/

#pragma once

#include <string>
#include <mutex>
#include <condition_variable>
#include <map>

#include <rapidjson/writer.h>
#include <rapidjson/stringbuffer.h>
#include <rapidjson/prettywriter.h>

#include <boost/function.hpp>
#include <boost/bind.hpp>

#include "sio_client.h"
#include "jsonBuilder.h"

namespace YA
{
	//Ϣ
	typedef boost::function<void( int, std::string const&, sio::message::ptr const&, bool, sio::message::list & )> MSG_HANDLE_FUNC_TYPE;

	class wsClient
	{
	private:
		sio::client __wsclient;//websocketͻ
		int __ID;//Ψһʶ
		std::string __uri;//ַ
		bool __Connected;//ǷϷ
		bool __SktOpened;//SocketǷѴ
		bool __Logined;//Ƿѵ¼ɹ
		std::condition_variable_any __cond;//
		std::mutex __lock;//(__cond)
		std::string __LastError;//´
		std::map<std::string, MSG_HANDLE_FUNC_TYPE> __MsgFuncList;//Ϣб(key,valueǴ)
		std::recursive_mutex __send_lock;//
		jsonBuilder __jsBuilder;//json
	protected:
		/**
		* @brief
		״̬

		* @param  \n

		* @return \n

		* @note

		* @warning

		* @bug

		*/
		void _reset();
		/**
		* @brief
		ӳɹص

		* @param  \n

		* @return \n

		* @note

		* @warning

		* @bug

		*/
		void _on_connected();
		/**
		* @brief
		ӹرջص

		* @param  [in] sio::client::close_reason const& reason رյԭ\n

		* @return \n

		* @note

		* @warning

		* @bug

		*/
		void _on_close( sio::client::close_reason const& reason );
		/**
		* @brief
		ص

		* @param  [in] unsigned p1 ???\n
		* @param  [in] unsigned p2 ???\n

		* @return \n

		* @note

		* @warning

		* @bug

		*/
		void _on_reconnect( unsigned p1, unsigned p2 );
		/**
		* @brief
		ʧܻص

		* @param  \n

		* @return \n

		* @note

		* @warning

		* @bug

		*/
		void _on_fail();
		/**
		* @brief
		socket򿪳ɹص

		* @param  \n

		* @return \n

		* @note

		* @warning

		* @bug

		*/
		void _on_socket_opened();
		/**
		* @brief
		յCALLص

		* @param  [in] std::string const& name  \n
		* @param  [in] sio::message::ptr const& data  յϢ\n
		* @param  [in] bool need_ack  ǷҪӦ\n
		* @param  [in] sio::message::list &ack_resp  ӦϢ\n

		* @return \n

		* @note

		* @warning

		* @bug

		*/
		void _OnCallMessage( std::string const& name, sio::message::ptr const& data, bool need_ack, sio::message::list &ack_resp );
		/**
		* @brief
		յ˵¼Ӧص

		* @param  [in] std::string const& name  \n
		* @param  [in] sio::message::ptr const& data  յϢ\n
		* @param  [in] bool need_ack  ǷҪӦ\n
		* @param  [in] sio::message::list &ack_resp  ӦϢ\n

		* @return \n

		* @note

		* @warning

		* @bug

		*/
		void _OnLoginResponse( std::string const& name, sio::message::ptr const& data, bool need_ack, sio::message::list &ack_resp );
	public:
		wsClient();
		~wsClient();
		/**
		* @brief
		ʼ

		* @param  [in] int ID  ǰͻ˵Ψһʶ\n
		* @param  [in] const std::string & uri  Ӵ\n
		* @param  [in] const std::map<std::string, MSG_HANDLE_FUNC_TYPE>& MsgFuncList  Ϣ\n

		* @return \n

		* @note

		* @warning

		* @bug

		*/
		void init( int ID, const std::string & uri, const std::map<std::string, MSG_HANDLE_FUNC_TYPE>& MsgFuncList );
		/**
		* @brief
		ַ

		* @param  \n

		* @return õַ\n

		* @note

		* @warning

		* @bug

		*/
		std::string get_uri();
		/**
		* @brief
		Ӻ

		* @param  [in] int time_out  ʱ(λ),Ĭ3\n

		* @return ӷǷɹ\n
		* @retval  0  ɹ\n
        * @retval  -1  ʧ\n

		* @note

		* @warning

		* @bug

		*/
		int connect( int time_out = 3 );
		/**
		* @brief
		¼

		* @param  \n

		* @return \n

		* @note

		* @warning

		* @bug

		*/
		void login();
		/**
		* @brief
		ݺ

		* @param  [in] const std::string & Cmd  Ҫ͵\n
		* @param  [in] const std::string& Data  Ҫ͵\n

		* @return \n

		* @note

		* @warning

		* @bug

		*/
		void send( const std::string & Cmd, const std::string & Data );
		/**
		* @brief
		ID

		* @param  \n

		* @return õID\n

		* @note

		* @warning

		* @bug

		*/
		int GetID();
		/**
		* @brief
		Ƿӷ˺

		* @param  \n

		* @return Ƿӷ\n

		* @note

		* @warning

		* @bug

		*/
		bool IsConnected();
		/**
		* @brief
		SocketǷѴ򿪺

		* @param  \n

		* @return SocketǷѴ\n

		* @note

		* @warning

		* @bug

		*/
		bool IsSktOpened();
		/**
		* @brief
		Ƿѵ¼ɹ

		* @param  \n

		* @return Ƿѵ¼ɹ\n

		* @note

		* @warning

		* @bug

		*/
		bool IsLogined();
		/**
		* @brief
		رպ

		* @param  \n

		* @return \n

		* @note

		* @warning

		* @bug

		*/
		void close();
		/**
		* @brief
		´

		* @param  \n

		* @return \n

		* @note

		* @warning

		* @bug

		*/
		std::string GetLastError();
	};
}